#region Copyright Syncfusion Inc. 2001 - 2016
// Copyright Syncfusion Inc. 2001 - 2016. All rights reserved.
// Use of this code is subject to the terms of our license.
// A copy of the current license can be obtained at any time by e-mailing
// licensing@syncfusion.com. Any infringement will be prosecuted under
// applicable laws. 
#endregion
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Syncfusion.Windows.Shared;
using System.Collections.ObjectModel;
using System.Windows.Input;
using System.ComponentModel;
using System.Runtime.CompilerServices;

namespace DoubleTextBoxDemo
{
    class ViewModel : NotificationObject, INotifyPropertyChanged
    {

        DoubleTextBox doubleTextBox;

        private IList<string> offsetValues =  new List<string>() { "mV", "V" };

        

        private double? _value = 0;
        public double? Value
        {
            get
            {
                return _value;
            }
            set
            {
                _value = value;
                RaisePropertyChanged(() => this.Value);
            }

        }

        public IList<string> OffsetValues
        {
            get
            {
                return offsetValues;
            }
            set
            {
                offsetValues = value;
            }
        }
       


        

        private ICommand valueChangedCommand;
        public ICommand ValueChangedCommand
        {
            get
            {
                if (valueChangedCommand == null)
                {
                    valueChangedCommand = new DelegateCommand<object>(ValueChanged);
                }
                return valueChangedCommand;
            }


        }

       




        double PreviousValue = 0;

        public void ValueChanged(object param)
        {
            if (Value != null)
            {
                if (param is DoubleTextBox)
                {
                    doubleTextBox = param as DoubleTextBox;

                  


                    if( ( Value != 0.0 ) && ( Value != PreviousValue + 1 ) && ( Value != PreviousValue - 1 ) )
                    {
                        _NodeCategory = "";
                        
                        //OnPropertyChanged( "NodeCategory" );
                         
                        isDropDownOpen = true;
                        OnPropertyChanged( "IsDropDownOpen" );
                      
                    }


                    
                }
                

                PreviousValue = Convert.ToDouble( Value );
            }
            

        }
      

        private bool isDropDownOpen;

        public bool IsDropDownOpen
        { 
            get { return isDropDownOpen; }
            set
            {
                isDropDownOpen = value;

                OnPropertyChanged();
            }
        }


         

        private string _NodeCategory;
        public string NodeCategory
        {
            get
            { 
                return _NodeCategory;
            }
            set
            {
                string gg = doubleTextBox.Name;
                double val = Convert.ToDouble( doubleTextBox.Value );

                if( val > 1000 )
                {
                    doubleTextBox.Value = 1.0;

                  

                }

                _NodeCategory = value;
                OnPropertyChanged("NodeCategory");

            }
        }


       

        protected virtual void OnPropertyChanged( [CallerMemberName]string propertyName = null )
        {
            PropertyChanged.Invoke( this, new PropertyChangedEventArgs( propertyName ) );
             
        }

        public event PropertyChangedEventHandler PropertyChanged;



 









    }






   



}
